//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

namespace Tecan.Sila2.Recovery
{


    ///  <summary>
    /// This feature enables SiLA error handling during the execution of observable commands.
    /// A client can subscribe to the property 'RecoverableErrors' which contains a list of recoverable errors that occurred and are not
    /// handled yet.
    /// If a recoverable error occurs during the execution of an observable command, a respective error object will be added to the list of
    /// the property 'RecoverableErrors'. Each error object contains the error description, the command execution UUID of the observable command
    /// execution during which the error occurred and a list of possible continuation options.
    /// To handle the error, the client sends one of the provided continuation options together with the command execution UUID, using the
    /// command 'ExecuteContinuationOption'.
    /// Within a continuation option the server can specify additional input data that has to be sent by the client in order to execute that
    /// continuation option, e.g. an adjusted parameter value. The structure of the required data has to be described in the 'RequiredInputData'
    /// field of the respective continuation option. The data must be contained in the 'InputData' field of the 'ExecuteContinuationOption'
    /// command.
    /// When the server receives the continuation option the according error object will be removed from the list of the property
    /// 'RecoverableErrors'.
    /// Instead of sending a continuation option the client alternatively can use the 'AbortErrorHandling' command (containing the
    /// command execution UUID) to stop the handling of the respective error. The server will treat this error as a 'normal' (not recovered) error
    /// using the standard error mechanism of SiLA.
    /// Via 'SetErrorHandlingTimeout' the maximum time can be specified that the server will wait for a continuation option before it sets itself
    /// into an internal error state and answers all following requests with an unrecoverable error. This can be used if an instrument must not
    /// be in a (blocked) waiting state in order to keep its functionality alive, because some service actions have to be performed within a
    /// certain time.
    /// In case of multi client access it is recommended that only one client (preferably the one that issued the according command execution)
    /// handles recoverable errors.
    /// </summary>
    [Tecan.Sila2.SilaFeatureAttribute( false, "core" )]
    [Tecan.Sila2.SilaIdentifierAttribute( "ErrorRecoveryService" )]
    [Tecan.Sila2.SilaDisplayNameAttribute( "Error Recovery Service" )]
    public partial interface IErrorRecoveryService
    {

        ///  <summary>
        /// A list of all recoverable errors that occurred during execution and have not been handled yet.
        /// </summary>
        [Tecan.Sila2.ObservableAttribute()]
        System.Collections.Generic.ICollection<RecoverableError> RecoverableErrors
        {
            get;
        }

        ///  <summary>
        /// Executes the selected option to recover the error.
        /// </summary>
        /// <param name="commandExecutionUUID">The UUID of the observable command execution for which the error shall be handled.</param>
        /// <param name="continuationOption">
        ///        The identifier of the continuation option to be executed. It must match the identifier of one of the continuation options
        ///        specified in the 'ContinuationOptions' list of the according 'RecoverableError' object.
        ///      </param>
        /// <param name="inputData">
        ///        If required this parameter contains the data that has to be sent along with a continuation option in order to execute the requested
        ///        recovery option. The kind of the data as well as the required format must be described in the 'RequiredInputData' field of the
        ///        respective continuation option.
        ///      </param>
        [Tecan.Sila2.ThrowsAttribute( typeof( InvalidCommandExecutionUUIDException ) )]
        [Tecan.Sila2.ThrowsAttribute( typeof( UnknownContinuationOptionException ) )]
        void ExecuteContinuationOption( [Tecan.Sila2.PatternConstraintAttribute( "[0-9a-f]{8}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{12}" )][Tecan.Sila2.SilaDisplayNameAttribute( "Command Execution UUID" )] string commandExecutionUUID, string continuationOption, Tecan.Sila2.DynamicClient.DynamicObjectProperty inputData );

        ///  <summary>
        /// Stops the handling of the error. The server will treat this error as a not recovered error.
        /// </summary>
        /// <param name="commandExecutionUUID">The UUID of the observable command execution for which the error handling shall be aborted.</param>
        [Tecan.Sila2.ThrowsAttribute( typeof( InvalidCommandExecutionUUIDException ) )]
        void AbortErrorHandling( [Tecan.Sila2.PatternConstraintAttribute( "[0-9a-f]{8}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{12}" )][Tecan.Sila2.SilaDisplayNameAttribute( "Command Execution UUID" )] string commandExecutionUUID );

        ///  <summary>
        /// Sets the maximum time that the server will wait for a continuation option in case of a recoverable error. If no continuation option is selected
        /// within the specified time all following requests will be answered with an unrecoverable error.
        /// A value of zero specifies an indefinite time, meaning that the server will wait till a continuation options is sent.
        /// </summary>
        /// <param name="errorHandlingTimeout">The timeout in seconds.</param>
        void SetErrorHandlingTimeout( Timeout errorHandlingTimeout );
    }

    ///  <summary>
    /// Describes an error that can be recovered by error handling. It contains error information (such as the command execution during
    /// which the error occurred, the time when the error occurred and the description of the error situation) and a list of possible
    /// continuation options.
    /// One of the continuation options can be marked as default option. A timeout can be specified for the automatic execution of
    /// that option if the client doesn't send a continuation option during the specified duration.
    /// </summary>
    public struct RecoverableError
    {

        private string _commandIdentifier;

        private string _commandExecutionUUID;

        private string _errorMessage;

        private System.Collections.Generic.ICollection<ContinuationOption> _continuationOptions;

        private string _defaultOption;

        private Timeout _automaticExecutionTimeout;

        ///  <summary>
        /// Initializes a new instance
        /// </summary>
        public RecoverableError( string commandIdentifier, string commandExecutionUUID, string errorMessage, System.Collections.Generic.ICollection<ContinuationOption> continuationOptions, string defaultOption, Timeout automaticExecutionTimeout )
        {
            _commandIdentifier = commandIdentifier;
            _commandExecutionUUID = commandExecutionUUID;
            _errorMessage = errorMessage;
            _continuationOptions = continuationOptions;
            _defaultOption = defaultOption;
            _automaticExecutionTimeout = automaticExecutionTimeout;
        }

        ///  <summary>
        /// The fully qualified identifier of the command whose execution produced the error.
        /// </summary>
        [Tecan.Sila2.SilaIdentifierTypeAttribute( Tecan.Sila2.IdentifierType.CommandIdentifier )]
        public string CommandIdentifier
        {
            get
            {
                return _commandIdentifier;
            }
        }

        ///  <summary>
        /// The UUID of the observable command execution during which the error occurred.
        /// </summary>
        [Tecan.Sila2.PatternConstraintAttribute( "[0-9a-f]{8}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{12}" )]
        public string CommandExecutionUUID
        {
            get
            {
                return _commandExecutionUUID;
            }
        }

        ///  <summary>
        /// This message describes the error situation. It should contain the reason of the error and additional error handling
        /// explanation.
        /// </summary>
        public string ErrorMessage
        {
            get
            {
                return _errorMessage;
            }
        }

        ///  <summary>
        /// A list of possible options to recover the error and continue the command execution.
        /// </summary>
        public System.Collections.Generic.ICollection<ContinuationOption> ContinuationOptions
        {
            get
            {
                return _continuationOptions;
            }
        }

        ///  <summary>
        /// The identifier of a continuation option that is marked as the preferred option. It must be an identifier of one of the
        /// continuation options of the 'ContinuationOptions' list.
        /// It can also be defined to be automatically executed after a timeout specified by the 'AutomaticExecutionTimeout' element.
        /// </summary>
        public string DefaultOption
        {
            get
            {
                return _defaultOption;
            }
        }

        ///  <summary>
        /// Specifies a timeout for handling the error by the client. If the client does not send a continuation option
        /// within the specified duration, the defined default option will automatically be executed.
        /// A value of 0 means, that no automatic execution will be done by the server.
        /// This timeout only takes effect if a default option is specified, otherwise it will be ignored.
        /// </summary>
        public Timeout AutomaticExecutionTimeout
        {
            get
            {
                return _automaticExecutionTimeout;
            }
        }
    }

    ///  <summary>
    /// Describes a possible option to recover an occurred error.
    /// </summary>
    public struct ContinuationOption
    {

        private string _identifier;

        private string _description;

        private string _requiredInputData;

        ///  <summary>
        /// Initializes a new instance
        /// </summary>
        public ContinuationOption( string identifier, string description, string requiredInputData )
        {
            _identifier = identifier;
            _description = description;
            _requiredInputData = requiredInputData;
        }

        ///  <summary>
        /// The identifier of the continuation option. It must be unique within the RecoverableError object.
        /// </summary>
        public string Identifier
        {
            get
            {
                return _identifier;
            }
        }

        ///  <summary>
        /// A human readable text describing the continuation option. It must explain all required manual actions by the operator
        /// as well as the actions that will be executed by the server and the expectable results when this option is selected.
        /// If there is additional data that can be sent along with the continuation option, the kind of the data as well as the
        /// required format must be described as well.
        /// </summary>
        public string Description
        {
            get
            {
                return _description;
            }
        }

        ///  <summary>
        /// This field defines the structure of the additional input data that is required in order to execute this continuation
        /// option. The format is a SiLA data type definition according to the schema DataTypes.xsd. If this field is empty no
        /// additional data is required.
        /// </summary>
        [Tecan.Sila2.SchemaAttribute( "https://gitlab.com/SiLA2/sila_base/raw/master/schema/DataTypes.xsd", Tecan.Sila2.SchemaType.Xml )]
        public string RequiredInputData
        {
            get
            {
                return _requiredInputData;
            }
        }
    }

    ///  <summary>
    /// The timeout in seconds
    /// </summary>
    [Tecan.Sila2.UnitAttribute( "s", Second = 1 )]
    [Tecan.Sila2.MinimalInclusiveAttribute( 0D )]
    public struct Timeout
    {

        private long _value;

        ///  <summary>
        /// Initializes a new instance
        /// </summary>
        public Timeout( long value )
        {
            _value = value;
        }

        ///  <summary>
        /// The inner value
        /// </summary>
        public long Value
        {
            get
            {
                return _value;
            }
        }
    }

    ///  <summary>
    /// The specified command execution UUID is not valid for error recovery. There is currently no unhandled recoverable error related
    /// to the specified command execution. A possibly occurred error might have been handled already by another client.
    /// </summary>
    [Tecan.Sila2.SilaDisplayNameAttribute( "Invalid Command Execution UUID" )]
    public class InvalidCommandExecutionUUIDException : System.Exception
    {

        ///  <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="message">The actual error message</param>
        public InvalidCommandExecutionUUIDException( string message ) :
                base( message )
        {
        }
    }

    ///  <summary>
    /// The specified continuation option is not defined for the error of the given observable command execution.
    /// </summary>
    public class UnknownContinuationOptionException : System.Exception
    {

        ///  <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="message">The actual error message</param>
        public UnknownContinuationOptionException( string message ) :
                base( message )
        {
        }
    }
}
